﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Reflection;

namespace Properties
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            
            MyClass p = new MyClass();
            p.Text = "abc";
            p.ctrl = this;
            propertyGrid1.SelectedObject = p;

            // info (p);
            info (this);
        }

        object obj;

        private void info (object p)
        {
           obj = p;
           // using System.Reflection;
           Type t = p.GetType ();

           TreeNode root = new TreeNode(t.Name);

           MethodInfo[] m = t.GetMethods();
           TreeNode item1 = new TreeNode("methods");
           root.Nodes.Add(item1);

           foreach (MethodInfo f in m)
           {
               var node = new TreeNode(f.Name);
               node.Tag = f;
               item1.Nodes.Add (node);
           }

           PropertyInfo [] a = t.GetProperties();
           TreeNode item2 = new TreeNode("properties");
           root.Nodes.Add(item2);

           foreach (PropertyInfo b in a)
           {
               var node = new TreeNode(b.Name);
               node.Tag = b;
               item2.Nodes.Add(node);
           }

           treeView1.Nodes.Add(root);
        }

        private void treeView1_AfterSelect(object sender, TreeViewEventArgs e)
        {
            table.Rows.Clear();
            MethodInfo f = e.Node.Tag as MethodInfo;
            if (f != null)
            {
                ParameterInfo [] parameters = f.GetParameters ();
                foreach (ParameterInfo p in parameters)
                {
                    object[] data = { p.ParameterType.Name, p.Name};
                    table.Rows.Add(data);
                }

                if (parameters.Length == 0)
                {
                    // obj.f(values);
                    object[] values = { };
                    f.Invoke (obj, values);
                }
            }

            /* ... */
            PropertyInfo b = e.Node.Tag as PropertyInfo;
            if (b != null)
            {
                object [] c = b.GetCustomAttributes(false);
                foreach (object d in c)
                {
                    object[] data = { d.GetType().Name, d.ToString () };
                    table.Rows.Add(data);
                }
            }


        }
    }
}
